#!/bin/bash
index=0

if [[ -z "$useraccount" ]]; then

    read -e -p "請輸入帳號: " useraccount

    if [[ -z "$useraccount" ]]; then
        echo "未輸入"
        exit
    fi
fi

userback_num=$(jetapi backup -F listBackups -D "type=127&accounts[]=${useraccount}" | tail -n 1 | sed 's/total://g' | sed s/[[:space:]]//g)

#判斷帳號是否存在
if [[ ${userback_num} == 0 ]]; then
    echo "
    查無備份檔
    "
    exit
fi

#抓備份硬碟id
D_id=$(jetapi backup -F listDestinations | grep '_id:' | head -n 1 | sed 's/_id: //g' | sed s/[[:space:]]//g)

#抓取備份時間
jetapi backup -F listBackups -D "type=127&destination=${D_id}&accounts[]=${useraccount}" | grep 'created' | grep -v 'snap_id' | cut -d : -f 2,3 | sed 's/T/-/g' >/root/jetbackup_log

#存檔為陣列
while read line; do
    dateA[$index]="$line"
    index=$(expr $index + 1)
done </root/jetbackup_log

echo '=============================================='
echo '下方時間請自行+8小時'

for ((index1 = 0; index1 < ${#dateA[@]}; index1++)); do

    echo "${index1}.    ${dateA[index1]}"

done
echo '=============================================='

#------------------------------------------------------------------------------------
#抓取日期格式
read -e -p "輸入日期編號: " restorenum

#抓取日期格式
restore_date=$(echo "${dateA[${restorenum}]}" | cut -d - -f 1,2,3,4 | sed "s/-/T/3")

echo "帳號:${useraccount} 還原日期: ${dateA[${restorenum}]}"

while [ -z "$yn_result" ]; do
    echo ""
    read -e -p "確定進行還原? Y or N: " realy_restore
    case "${realy_restore}" in
    [Yy]) # y,Y
        yn_result=0
        ;;
    [Nn]) # n,N
        echo '還原取消'
        exit
        ;;
    *)
        echo "請輸入 y or n: "
        ;;
    esac
done

if [[ ${yn_result} == 0 ]]; then

    #抓取備份日期id
    restoreid=$(jetapi backup -F listBackups -D "type=127&destination=${D_id}&accounts[]=${useraccount}" | grep -B 10 ${restore_date} | head -n 1 | sed 's/_id: //g' | sed s/[[:space:]]//g)

    #正式還原指令
    jetapi backup -F addQueueRestore -D "_id=${restoreid}" >/root/jetbackup_log_restore

    #抓取還原id
    a=$(cat /root/jetbackup_log_restore | grep -w '_id:' | sed 's/_id: //g' | sed s/[[:space:]]//g)

    echo '=============================================='
    echo '               還原開始                        '
    echo '=============================================='

    #SHOW 還原LOG
    /usr/bin/jetcli backup -vR restore -I ${a}

    #刪除檔案
    rm -f /root/jetbackup_log_restore
fi

